#!/bin/bash
function stop_cups() { 
	/etc/init.d/cups stop
} 
function start_cups() {
	/etc/init.d/cups start
}
function fake_hp_backend() {
	if [ ! -f /usr/lib/cups/backend/hp ]; then return; fi
	if [ -h /usr/lib/cups/backend/hp -a "$(readlink /usr/lib/cups/backend/hp)" == "/opt/printspy/backend/bin/psbackend" ]; then return; fi 
	mv /usr/lib/cups/backend/hp /usr/lib/cups/backend/hpprintspy
	cp -P /usr/lib/cups/backend/printspy /usr/lib/cups/backend/hp	
}
function handle_error() {
    errcode=$? # save the exit code as the first thing done in the trap function
    echo "error $errorcode"
    echo "the command executing at the time of the error was"
    echo "$BASH_COMMAND"
    echo "on line ${BASH_LINENO[0]}"
    exit $?
}
function handle_error_restorecups() {
	errocode = $?
	start_cups
	handle_error $errcode 
}
trap handle_error ERR
if [ "$(id -u)" != "0" ]; then 
	echo "Usage: sudo ./attach-all.sh" 1>&2
	exit 1 
fi 
stop_cups 
trap handle_error_restorecups ERR
fake_hp_backend
sed -i.before-printspy-attach '/printspy/b; /^DeviceURI\s\+hp:/! s/^DeviceURI\s\+/DeviceURI printspy:/' /etc/cups/printers.conf
sed -i '/printspy/b; s/^DeviceURI\s\+hp:/DeviceURI hp:hpprintspy:/' /etc/cups/printers.conf
start_cups

